/*******************************************************************************
 * FoxPawn_HardSuit generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxPawn_HardSuit extends FoxVehicle
    abstract
    native(Vehicle)
    config(Pawn)
    hidecategories(Navigation);

enum HardSuitBurnState
{
    EHSBS_NotBurning,
    EHSBS_RampingUp,
    EHSBS_Burning,
    EHSBS_RampingDown,
    EHSBS_MAX
};

struct native VulnerablePoint
{
    var name AttachBoneName;
    var array<name> BoneNames;
    var StaticMesh AttachmentMesh;
    var float DamageModifier;

    structdefaultproperties
    {
        AttachBoneName=None
        BoneNames=none
        AttachmentMesh=none
        DamageModifier=10.0
    }
};

var protected export editinline ParticleSystemComponent LeftEnginePSComp;
var protected const ParticleSystem LeftEngineNormalSystem;
var protected const ParticleSystem LeftEngineBoostSystem;
var protected const name LeftEnginePSSocketName;
var protected const ParticleSystem LeftEngineBoostShutdownSystem;
var protected export editinline ParticleSystemComponent RightEnginePSComp;
var protected const ParticleSystem RightEngineNormalSystem;
var protected const ParticleSystem RightEngineBoostSystem;
var protected const name RightEnginePSSocketName;
var protected const ParticleSystem RightEngineBoostShutdownSystem;
var protected export editinline ParticleSystemComponent LeftFootPSComp;
var protected const name LeftFootPSSocketName;
var protected export editinline ParticleSystemComponent RightFootPSComp;
var protected const name RightFootPSSocketName;
var protected export editinline ParticleSystemComponent BaseBoostPSComp;
var protected const name BaseBoostPSCompName;
var protected export editinline ParticleSystemComponent SpawnDropPSComp;
var protected const name SpawnDropPSCompName;
var protected export editinline MaterialInstanceConstant LowerBodyBurnMIC;
var protected export editinline MaterialInstanceConstant UpperBodyBurnMIC;
var protected export editinline MaterialInstanceConstant FPBurnMIC;
var protected const LinearColor FriendlyFlameColor;
var protected const LinearColor EnemyFlameColor;
var protected repnotify byte CamoIndex;
var private FoxPawn_HardSuit.HardSuitBurnState BurnState;
var() protected repnotify transient byte CurrentVulnerablePointIndex;
var repnotify transient FoxTypes.EHardSuitWeakPointUIState BattleModeState;
var private transient float HardSuitBurnStateTime;
var private repnotify transient bool bOnFire;
var repnotify transient bool bBoostEnabled;
var private repnotify transient bool bTriggerSpawnEffects;
var() protected transient bool bIsUsingWeakPointArmor;
var protected const name HeatInterpParamName;
var protected const float HeatInterpTime;
var protected const float HeatInterpBeginVal;
var protected const float HeatInterpEndVal;
var protected class<FoxWeapon> LeftWeaponClass;
var protected class<FoxWeapon> RightWeaponClass;
var private const float FrictionCoefficient;
var protected array<VulnerablePoint> VulnerablePoints;
var private const PhysicalMaterial VulnerablePhysMat;
var() protected transient VulnerablePoint CurrentVulnerablePoint;
var() protected const config float BattleModeDamageModifier;
var() protected const export editinline transient StaticMeshComponent VulnerableMeshComp;
var protected transient FoxWeapon LeftWeapon;
var protected transient FoxWeapon RightWeapon;
var private float TurnScale;
var() private export editinline SkeletalMeshComponent VisorMeshComp;
var() private export editinline StaticMeshComponent VisorMeshCompInner;
var private const name CenterWindowSocketName;
var private const int VisorMeshMaxPitch;
var private const int VisorMeshMinPitch;
var private const int VisorPitchDeadZone;
var private const int VisorPitchPerSecond;
var private const float VisorYawDeltaDegMax;
var private const float VisorYawDeltaDegMin;
var private const AkEvent AmbientHumStart;
var private const AkEvent AmbientHumStop;
var private const AkEvent FlameThrowerDamageAkEvent;
var private const AkEvent FlameThrowerDamageEndAkEvent;
var private const AkEvent WeakPointArmorStart;
var private const AkEvent WeakPointArmorStop;
var private const AkEvent WeakPointArmorCooledDown;
var private const name AmbientHumRTPCName;
var private const AkEvent FPWeakPointImpact;
var private const AkEvent FPNormalImpact;
var const AkEvent SpawnEvent;
var const float MyHardSuitEnterTime;
var const float OtherHardSuitEnterTime;
var private const export editinline PointLightComponent DeathLightComp;
var private const float DeathLightRampUpTime;
var private const float DeathLightRampUpIntensity;
var private const float DeathLightRampDownStartIntensity;
var private const float DeathLightRampDownTime;
var() private const float WeakPointDuration;
var() private const float WeakPointCooldown;
var transient float WeakPointTimer;
var private FoxPawn LastDriver;
var int OwningPlayerId;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        BattleModeState, CamoIndex, 
        CurrentVulnerablePointIndex, WeakPointTimer, 
        bBoostEnabled, bOnFire, 
        bTriggerSpawnEffects

    // Pos:0x020
    if(bNetInitial && Role == ROLE_Authority)
        OwningPlayerId
}

simulated event ReplicatedEvent(name VarName)
{
    // End:0x24
    if(VarName == 'CurrentVulnerablePointIndex')
    {
        UpdateVulnerableWeakPoint();
    }
    // End:0x107
    else
    {
        // End:0x51
        if(VarName == 'BattleModeState')
        {
            BattleModeStateChange(BattleModeState);
        }
        // End:0x107
        else
        {
            // End:0x7F
            if(VarName == 'bBoostEnabled')
            {
                ToggleSprintEffects(bBoostEnabled);
            }
            // End:0x107
            else
            {
                // End:0xA3
                if(VarName == 'bTriggerSpawnEffects')
                {
                    StartDropEffects();
                }
                // End:0x107
                else
                {
                    // End:0xC7
                    if(VarName == 'bOnFire')
                    {
                        UpdateBurn();
                    }
                    // End:0x107
                    else
                    {
                        // End:0xF4
                        if(VarName == 'CamoIndex')
                        {
                            SetCamoIndex(CamoIndex);
                        }
                        // End:0x107
                        else
                        {
                            super.ReplicatedEvent(VarName);
                        }
                    }
                }
            }
        }
    }
    //return;    
}

simulated function SetCamoIndex(const byte NewCamoIndex)
{
    CamoIndex = NewCamoIndex;
    SetEmissives();
    //return;    
}

simulated function LinearColor GetFlameColorsFor(bool bFriendly)
{
    // End:0x17
    if(bFriendly)
    {
        return FriendlyFlameColor;
    }
    return EnemyFlameColor;
    //return ReturnValue;    
}

simulated event Destroyed()
{
    super.Destroyed();
    LeftWeapon = none;
    RightWeapon = none;
    PostAkEvent(AmbientHumStop);
    //return;    
}

function PlayHit(float Damage, Controller InstigatedBy, Vector HitLocation, class<DamageType> DamageType, Vector Momentum, TraceHitInfo HitInfo)
{
    super(FoxPawn).PlayHit(Damage, InstigatedBy, HitLocation, DamageType, Momentum, HitInfo);
    // End:0x65
    if(class<FoxDamageType_Corrosive>(DamageType) != none)
    {
        ClientNotifyBurnDamage();
    }
    // End:0xAB
    else
    {
        ClientNotifyPlayHitBone(HitInfo.BoneName, vector(InstigatedBy.Rotation));
    }
    //return;    
}

unreliable client simulated function ClientNotifyPlayHitBone(const name BoneName, Vector OppVector)
{
    // End:0x5C
    if((Driver != none) && IsLocallyControlled())
    {
        PostAkEvent(((IsVulnerableBone(BoneName, OppVector)) ? FPWeakPointImpact : FPNormalImpact));
    }
    //return;    
}

unreliable client simulated function ClientNotifyBurnDamage()
{
    // End:0x32
    if((Driver != none) && IsLocallyControlled())
    {
        PostAkEvent(FlameThrowerDamageAkEvent);
    }
    //return;    
}

simulated event NotifyNewDamageOverTime(class<FoxDamageType_Corrosive> DamageTypeClass)
{
    // End:0x3D
    if(!IsBattleModeActive() && CanDamageTypeBurnDriver(DamageTypeClass))
    {
        bOnFire = true;
        UpdateBurn();
    }
    //return;    
}

simulated function UpdateBurn()
{
    // End:0x68
    if(bOnFire)
    {
        switch(BurnState)
        {
            // End:0x4E
            case 0:
                BurnState = 1;
                HardSuitBurnStateTime = 0.0;
                SwapBurnMICs(true);
                // End:0x65
                break;
            // End:0x62
            case 3:
                BurnState = 1;
                // End:0x65
                break;
            // End:0xFFFF
            default:
                // End:0xB9
                break;
            }
    }
    switch(BurnState)
    {
        // End:0x8F
        case 1:
            BurnState = 3;
            // End:0xB9
            break;
        // End:0xB6
        case 2:
            BurnState = 3;
            HardSuitBurnStateTime = HeatInterpTime;
            // End:0xB9
            break;
        // End:0xFFFF
        default:
            //return;
    }    
}

simulated event NotifyDamageOverTimeFinished(class<FoxDamageType_Corrosive> DamageTypeClass)
{
    // End:0x2C
    if(CanDamageTypeBurnDriver(DamageTypeClass))
    {
        bOnFire = false;
        UpdateBurn();
    }
    //return;    
}

simulated event SwapBurnMICs(bool bBurnOn)
{
    local int I;

    // End:0xEA
    if(bBurnOn)
    {
        Mesh.SetMaterial(0, UpperBodyBurnMIC);
        Mesh.SetMaterial(1, LowerBodyBurnMIC);
        // End:0xE7
        if(VisorMeshComp != none)
        {
            VisorMeshComp.SetMaterial(0, FPBurnMIC);
            VisorMeshComp.SetLightEnvironment(LightEnvironment);
            VisorMeshCompInner.SetLightEnvironment(LightEnvironment);
        }
    }
    // End:0x239
    else
    {
        I = 0;
        J0xF5:
        // End:0x16B [Loop If]
        if(I < Mesh.GetNumElements())
        {
            Mesh.SetMaterial(I, TPCamoSwapLowerBodyMeshMICs[I]);
            ++ I;
            // [Loop Continue]
            goto J0xF5;
        }
        // End:0x239
        if(VisorMeshComp != none)
        {
            I = 0;
            J0x185:
            // End:0x1E9 [Loop If]
            if(I < VisorMeshComp.GetNumElements())
            {
                VisorMeshComp.SetMaterial(I, none);
                ++ I;
                // [Loop Continue]
                goto J0x185;
            }
            VisorMeshComp.SetLightEnvironment(LightEnvironment);
            VisorMeshCompInner.SetLightEnvironment(LightEnvironment);
        }
    }
    //return;    
}

protected simulated function AkEvent GetSpecificFootStepSound(FoxPMPInfo_FootSteps FootStepInfo)
{
    return FootStepInfo.MechFootStepSound;
    //return ReturnValue;    
}

protected function ParticleSystem GetSpecificFootStepParticleSystem(FoxPMPInfo_FootSteps FootStepInfo)
{
    return FootStepInfo.MechFootStepParticleSystem;
    //return ReturnValue;    
}

simulated function PostBeginPlay()
{
    super.PostBeginPlay();
    // End:0x1DA
    if(Role == ROLE_Authority)
    {
        // End:0xD8
        if(RightWeaponClass != none)
        {
            RightWeapon = FoxWeapon(AddInventory(RightWeaponClass, false));
            SetSlotAttachment(RightWeaponClass.default.WeaponSlot, RightWeaponClass.default.WeaponAttachmentClass);
            RightWeapon.Activate();
            RightWeapon.SeedSpread();
        }
        // End:0x1DA
        if(LeftWeaponClass != none)
        {
            LeftWeapon = FoxWeapon(AddInventory(LeftWeaponClass, false));
            SetSlotAttachment(LeftWeaponClass.default.WeaponSlot, LeftWeaponClass.default.WeaponAttachmentClass);
            LeftWeapon.Activate();
            LeftWeapon.SeedSpread();
            // End:0x1DA
            if(LeftWeapon.CanScope())
            {
                Weapon = LeftWeapon;
                MyFoxWeapon = LeftWeapon;
            }
        }
    }
    // End:0x378
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        Mesh.AttachComponentToSocket(LeftEnginePSComp, LeftEnginePSSocketName);
        Mesh.AttachComponentToSocket(RightEnginePSComp, RightEnginePSSocketName);
        Mesh.AttachComponentToSocket(LeftFootPSComp, LeftFootPSSocketName);
        Mesh.AttachComponentToSocket(RightFootPSComp, RightFootPSSocketName);
        Mesh.AttachComponentToSocket(BaseBoostPSComp, BaseBoostPSCompName);
        Mesh.AttachComponentToSocket(VisorMeshComp, 'HUD');
        Mesh.AttachComponentToSocket(VisorMeshCompInner, 'HUD');
        PostAkEvent(AmbientHumStart);
        SetupCamoParams();
    }
    StartDropEffects();
    ToggleSprintEffects(false);
    // End:0x3C3
    if(Role == ROLE_Authority)
    {
        CurrentVulnerablePointIndex = byte(Rand(VulnerablePoints.Length));
        UpdateVulnerableWeakPoint();
    }
    SetDesiredRotationHard(Rotation);
    //return;    
}

simulated function AttachWeapon(FoxWeapon InWeapon)
{
    super(FoxPawn).AttachWeapon(InWeapon);
    // End:0x9A
    if(InWeapon.Class == LeftWeaponClass)
    {
        LeftWeapon = InWeapon;
        // End:0x9A
        if(LeftWeapon.CanScope())
        {
            Weapon = LeftWeapon;
            MyFoxWeapon = LeftWeapon;
        }
    }
    // End:0xD9
    if(InWeapon.Class == RightWeaponClass)
    {
        RightWeapon = InWeapon;
    }
    //return;    
}

simulated function StartDropEffects()
{
    // End:0x20
    if(Role == ROLE_Authority)
    {
        bTriggerSpawnEffects = true;
    }
    // End:0x40
    if(bTriggerSpawnEffects)
    {
        AttachComponent(SpawnDropPSComp);
    }
    //return;    
}

// Export UFoxPawn_HardSuit::execSetDesiredRotationHard(FFrame&, void* const)
native simulated function SetDesiredRotationHard(const Rotator NewRotation);

simulated function UpdateVulnerableWeakPoint()
{
    // End:0x38
    if(IsBattleModeActive())
    {
        Mesh.DetachComponent(VulnerableMeshComp);
    }
    // End:0xF4
    else
    {
        // End:0xF4
        if(VulnerablePoints.Length > CurrentVulnerablePointIndex)
        {
            CurrentVulnerablePoint = VulnerablePoints[CurrentVulnerablePointIndex];
            VulnerableMeshComp.SetStaticMesh(CurrentVulnerablePoint.AttachmentMesh);
            Mesh.AttachComponent(VulnerableMeshComp, CurrentVulnerablePoint.AttachBoneName);
        }
    }
    //return;    
}

simulated function bool IsBattleModeActive()
{
    return BattleModeState == 1;
    //return ReturnValue;    
}

simulated function bool IsBattleModeReady()
{
    return BattleModeState == 0;
    //return ReturnValue;    
}

reliable server function ServerActivateBattleMode()
{
    // End:0x57
    if(((Controller != none) && FoxPC(Controller).HasBattleModeTacticalItem()) && IsBattleModeReady())
    {
        BattleModeStateChange(1);
    }
    //return;    
}

simulated event BattleModeStateChange(FoxTypes.EHardSuitWeakPointUIState NewState)
{
    local int I;
    local DOTInfo RefToDotInfo;

    WeakPointTimer = 0.0;
    BattleModeState = NewState;
    // End:0x99
    if(IsLocallyControlled())
    {
        switch(BattleModeState)
        {
            // End:0x5E
            case 0:
                PostAkEvent(WeakPointArmorCooledDown);
                // End:0x99
                break;
            // End:0x7A
            case 1:
                PostAkEvent(WeakPointArmorStart);
                // End:0x99
                break;
            // End:0x96
            case 2:
                PostAkEvent(WeakPointArmorStop);
                // End:0x99
                break;
            // End:0xFFFF
            default:
            }
            // End:0x24D
            if(Role == ROLE_Authority)
            {
                switch(BattleModeState)
                {
                    // End:0x185
                    case 1:
                        I = 0;
                        J0xD0:
                        // End:0x182 [Loop If]
                        if(I < MyDOTs.Length)
                        {
                            // End:0x174
                            if(CanDamageTypeBurnDriver(MyDOTs[I].DamageType))
                            {
                                RefToDotInfo = MyDOTs[I];
                                RefToDotInfo.DamageType.static.EffectEnded(RefToDotInfo, self);
                            }
                            ++ I;
                            // [Loop Continue]
                            goto J0xD0;
                        }
                        // End:0x24D
                        break;
                    // End:0x24A
                    case 2:
                        I = 0;
                        J0x195:
                        // End:0x247 [Loop If]
                        if(I < MyDOTs.Length)
                        {
                            // End:0x239
                            if(CanDamageTypeBurnDriver(MyDOTs[I].DamageType))
                            {
                                RefToDotInfo = MyDOTs[I];
                                RefToDotInfo.DamageType.static.EffectStarted(RefToDotInfo, self);
                            }
                            ++ I;
                            // [Loop Continue]
                            goto J0x195;
                        }
                        // End:0x24D
                        break;
                    // End:0xFFFF
                    default:
                    }
                    UpdateVulnerableWeakPoint();
                    //return;                    
}

simulated function ToggleHRVEffects(const bool bEnabled, const bool bFriendly, const bool bHardSuitHRV)
{
    super.ToggleHRVEffects(bEnabled, bFriendly, bHardSuitHRV);
    // End:0x89
    if(((bEnabled && !bFriendly) && !bIsUsingWeakPointArmor) && IsAliveAndWell())
    {
        VulnerableMeshComp.SetHidden(false);
    }
    // End:0xA9
    else
    {
        VulnerableMeshComp.SetHidden(true);
    }
    //return;    
}

simulated function SetGearFromLoadout()
{
    //return;    
}

simulated function SetFlashLocation(Weapon InWeapon, byte InFiringMode, Vector NewLoc)
{
    FlashLocation.OptionalFlag = FoxWeapon(InWeapon).WeaponSlot;
    super(Pawn).SetFlashLocation(InWeapon, InFiringMode, NewLoc);
    //return;    
}

simulated function ClearFlashLocation(Weapon InWeapon)
{
    // End:0xBB
    if(!IsZero(FlashLocation.Location))
    {
        bForceNetUpdate = true;
        FlashLocation.Location = vect(0.0, 0.0, 0.0);
        FlashLocation.OptionalFlag = FoxWeapon(InWeapon).WeaponSlot;
        FlashLocationUpdated(InWeapon, FlashLocation, false);
    }
    //return;    
}

simulated function FlashLocationUpdated(Weapon InWeapon, const out FlashLocData InFlashLocation, bool bViaReplication)
{
    local Weapon RealWeapon;

    // End:0x81
    if((RightWeapon != none) && LeftWeapon != none)
    {
        RealWeapon = ((InFlashLocation.OptionalFlag == RightWeapon.WeaponSlot) ? RightWeapon : LeftWeapon);
    }
    super(Pawn).FlashLocationUpdated(RealWeapon, InFlashLocation, bViaReplication);
    //return;    
}

// Export UFoxPawn_HardSuit::execIsReloadingWeapon(FFrame&, void* const)
native simulated function bool IsReloadingWeapon();

simulated function AbortReloading()
{
    // End:0x52
    if((LeftWeapon != none) && LeftWeapon.IsReloading())
    {
        LeftWeapon.AbortReload();
    }
    // End:0xA4
    if((RightWeapon != none) && RightWeapon.IsReloading())
    {
        RightWeapon.AbortReload();
    }
    //return;    
}

function AdjustDriverDamage(out int Damage, Controller InstigatedBy, Vector HitLocation, out Vector Momentum, class<DamageType> DamageType)
{
    // End:0x2A
    if((InGodMode()) || IsBattleModeActive())
    {
        Damage = 0;
    }
    // End:0xA3
    else
    {
        // End:0x8F
        if(class<FoxDamageType_Corrosive>(DamageType) != none)
        {
            // End:0x8C
            if(FoxPC(InstigatedBy) != none)
            {
                Damage *= class<FoxDamageType_Corrosive>(DamageType).default.PercentageToDriver;
            }
        }
        // End:0xA3
        else
        {
            Damage *= DriverDamageMult;
        }
    }
    //return;    
}

function AdjustDamage(out int InDamage, out Vector Momentum, Controller InstigatedBy, Vector HitLocation, class<DamageType> DamageType, TraceHitInfo HitInfo, Actor DamageCauser)
{
    super(FoxPawn).AdjustDamage(InDamage, Momentum, InstigatedBy, HitLocation, DamageType, HitInfo, DamageCauser);
    // End:0x6D
    if(IsBattleModeActive())
    {
        InDamage *= BattleModeDamageModifier;
    }
    // End:0xEE
    else
    {
        // End:0xEE
        if((DamageCauser != none) && IsVulnerableBone(HitInfo.BoneName, vector(DamageCauser.Rotation)))
        {
            InDamage *= CurrentVulnerablePoint.DamageModifier;
        }
    }
    //return;    
}

simulated function bool IsVulnerableBone(const name InBoneName, const Vector OppVector)
{
    local int I;

    // End:0x1E
    if(bIsUsingWeakPointArmor || IsBattleModeActive())
    {
        return false;
    }
    I = 0;
    J0x29:
    // End:0xDB [Loop If]
    if(I < CurrentVulnerablePoint.BoneNames.Length)
    {
        // End:0xCD
        if(InBoneName == CurrentVulnerablePoint.BoneNames[I])
        {
            // End:0xCB
            if(InStr(string(InBoneName), "back") != -1)
            {
                // End:0xC8
                if((OppVector Dot vector(Rotation)) >= float(0))
                {
                    return true;
                }
            }
            // End:0xCD
            else
            {
                return true;
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x29;
    }
    return false;
    //return ReturnValue;    
}

function name GetVulnerableBone()
{
    // End:0x4B
    if((bIsUsingWeakPointArmor || IsBattleModeActive()) || CurrentVulnerablePoint.BoneNames.Length < 1)
    {
        return 'None';
    }
    return CurrentVulnerablePoint.BoneNames[0];
    //return ReturnValue;    
}

simulated event PhysicalMaterial GetPawnPhysMatFor(const out ImpactInfo Impact)
{
    // End:0x67
    if(IsVulnerableBone(Impact.HitInfo.BoneName, -Impact.HitNormal))
    {
        return VulnerablePhysMat;
    }
    // End:0x7B
    else
    {
        return super(FoxPawn).GetPawnPhysMatFor(Impact);
    }
    //return ReturnValue;    
}

simulated function bool CanSwitchWeapon()
{
    return false;
    //return ReturnValue;    
}

simulated function bool CanUseHRV(const bool bTurnOn)
{
    local FoxPRI PRI;

    PRI = FoxPRI(PlayerReplicationInfo);
    return ((((super(FoxPawn).CanUseHRV(bTurnOn) && PRI != none) && PRI.Loadout != none) && (Driver.GearInfo.TacticalID >= 0) && Driver.GearInfo.TacticalID < PRI.Loadout.UnlockablesDataStore.TacticalProviderArray.Length) && FoxDataProvider_GearInfo(PRI.Loadout.UnlockablesDataStore.TacticalProviderArray[Driver.GearInfo.TacticalID]) != none) && FoxDataProvider_GearInfo(PRI.Loadout.UnlockablesDataStore.TacticalProviderArray[Driver.GearInfo.TacticalID]).TacticalTypeID == 7;
    //return ReturnValue;    
}

reliable server function ServerUseHRVPing()
{
    local FoxPC PC;

    AuthorityTryUseHRV(true);
    // End:0x75
    foreach WorldInfo.AllControllers(class'FoxPC', PC)
    {
        // End:0x74
        if(IsBeingFPSpectatedBy(PC))
        {
            PC.ClientSpectateHRVPing();
        }        
    }    
    //return;    
}

function bool StopFiring()
{
    // End:0x30
    if(LeftWeapon != none)
    {
        LeftWeapon.StopFire(0);
    }
    // End:0x60
    if(RightWeapon != none)
    {
        RightWeapon.StopFire(0);
    }
    return super(Pawn).StopFiring();
    //return ReturnValue;    
}

simulated function StartFire(byte FireModeNum)
{
    local bool bLocalUsingGamepad;

    bLocalUsingGamepad = false;
    // End:0x1B
    if(bNoWeaponFiring)
    {
        return;
    }
    // End:0xBB
    if(((Controller != none) && FoxPC(Controller) != none) && FoxPC(Controller).MyFoxInput != none)
    {
        bLocalUsingGamepad = FoxPC(Controller).MyFoxInput.bUsingGamepad;
    }
    // End:0x112
    if(!WorldInfo.IsConsoleBuild() && !bLocalUsingGamepad)
    {
        FireModeNum = byte((FireModeNum + 1) % 2);
    }
    // End:0x15B
    if((FireModeNum == 0) && LeftWeapon != none)
    {
        LeftWeapon.StartFire(0);
    }
    // End:0x18B
    else
    {
        // End:0x18B
        if(RightWeapon != none)
        {
            RightWeapon.StartFire(0);
        }
    }
    //return;    
}

simulated function DisplayDebug(HUD HUD, out float out_YL, out float out_YPos)
{
    super(FoxPawn).DisplayDebug(HUD, out_YL, out_YPos);
    // End:0xE2
    if(HUD.ShouldDisplayDebug('Weapon'))
    {
        // End:0x99
        if(LeftWeapon != none)
        {
            LeftWeapon.DisplayDebug(HUD, out_YL, out_YPos);
        }
        // End:0xE2
        if(RightWeapon != none)
        {
            RightWeapon.DisplayDebug(HUD, out_YL, out_YPos);
        }
    }
    //return;    
}

simulated function PlayEmote(FoxDataProvider_Emote InEmote)
{
    // End:0x53
    if(FoxPC(Controller) != none)
    {
        SpecialMoveInt = 498;
        FoxPC(Controller).DoSpecialMove(8, false, false);
    }
    //return;    
}

function PossessedBy(Controller C, bool bVehicleTransition)
{
    super.PossessedBy(C, bVehicleTransition);
    // End:0xA0
    if(C.IsA('PlayerController'))
    {
        // End:0x70
        if(LeftWeapon != none)
        {
            LeftWeapon.ClientWeaponSet(false);
        }
        // End:0xA0
        if(RightWeapon != none)
        {
            RightWeapon.ClientWeaponSet(false);
        }
    }
    //return;    
}

simulated function StartReload()
{
    // End:0x2E
    if(LeftWeapon != none)
    {
        LeftWeapon.StartReload();
    }
    // End:0x5C
    if(RightWeapon != none)
    {
        RightWeapon.StartReload();
    }
    //return;    
}

simulated function FoxWeapon GetWeaponForFireMode(const byte FireMode)
{
    // End:0x32
    if((FireMode == 0) && LeftWeapon != none)
    {
        return LeftWeapon;
    }
    // End:0x4B
    else
    {
        // End:0x4B
        if(RightWeapon != none)
        {
            return RightWeapon;
        }
    }
    return none;
    //return ReturnValue;    
}

simulated function ProcessViewRotation(float DeltaTime, out Rotator out_ViewRotation, out Rotator out_DeltaRot)
{
    local Rotator PCYawNorm, PawnYawNorm;
    local float DegreesBetween;

    // End:0x17E
    if(VisorYawDeltaDegMax > float(0))
    {
        PCYawNorm.Yaw = out_ViewRotation.Yaw + out_DeltaRot.Yaw;
        PawnYawNorm.Yaw = Rotation.Yaw;
        DegreesBetween = RDiff(PCYawNorm, PawnYawNorm);
        // End:0xFF
        if(DegreesBetween > VisorYawDeltaDegMax)
        {
            out_DeltaRot.Yaw = 0;
        }
        // End:0x17E
        else
        {
            // End:0x17E
            if(DegreesBetween >= VisorYawDeltaDegMin)
            {
                out_DeltaRot.Yaw *= FInterpEaseInOut(1.0, -1.0, (0.50 * (DegreesBetween - VisorYawDeltaDegMin)) / (VisorYawDeltaDegMax - VisorYawDeltaDegMin), 2.0);
            }
        }
    }
    super(Pawn).ProcessViewRotation(DeltaTime, out_ViewRotation, out_DeltaRot);
    //return;    
}

simulated function StopFire(byte FireModeNum)
{
    local bool bLocalUsingGamepad;

    bLocalUsingGamepad = false;
    // End:0xAC
    if(((Controller != none) && FoxPC(Controller) != none) && FoxPC(Controller).MyFoxInput != none)
    {
        bLocalUsingGamepad = FoxPC(Controller).MyFoxInput.bUsingGamepad;
    }
    // End:0x103
    if(!WorldInfo.IsConsoleBuild() && !bLocalUsingGamepad)
    {
        FireModeNum = byte((FireModeNum + 1) % 2);
    }
    // End:0x14C
    if((FireModeNum == 0) && LeftWeapon != none)
    {
        LeftWeapon.StopFire(0);
    }
    // End:0x17C
    else
    {
        // End:0x17C
        if(RightWeapon != none)
        {
            RightWeapon.StopFire(0);
        }
    }
    //return;    
}

simulated function ZoomKeyToggleOverride(const bool bReleased)
{
    // End:0x7E
    if(PlayerController(Controller) != none)
    {
        // End:0x54
        if(!bReleased)
        {
            PlayerController(Controller).StartFire(1);
        }
        // End:0x7E
        else
        {
            PlayerController(Controller).StopFire(1);
        }
    }
    //return;    
}

simulated function bool IsFiring()
{
    // End:0x35
    if((LeftWeapon != none) && LeftWeapon.IsFiring())
    {
        return true;
    }
    // End:0x6A
    if((RightWeapon != none) && RightWeapon.IsFiring())
    {
        return true;
    }
    return false;
    //return ReturnValue;    
}

simulated function ZoomKeyHoldOverride(const bool bReleased)
{
    // End:0x7E
    if(PlayerController(Controller) != none)
    {
        // End:0x54
        if(!bReleased)
        {
            PlayerController(Controller).StartFire(1);
        }
        // End:0x7E
        else
        {
            PlayerController(Controller).StopFire(1);
        }
    }
    //return;    
}

simulated function float PlayBodyStance(BodyStance Stance, float Rate, optional float BlendInTime, optional float BlendOutTime, optional bool bLooping, optional bool bOverride, optional bool bKeepRBASettings, optional bool bForceThird)
{
    local int I;
    local float Duration;

    bOverride = true;        
    I = 0;
    J0x15:
    // End:0x1F5 [Loop If]
    if(I < Stance.AnimName.Length)
    {
        // End:0x1E7
        if(((Stance.AnimName[I] != 'None') && I < BodyStanceNodes.Length) && BodyStanceNodes[I] != none)
        {
            Duration = BodyStanceNodes[I].PlayCustomAnim(Stance.AnimName[I], Rate, BlendInTime, BlendOutTime, bLooping, bOverride);
            // End:0x1A9
            if(Duration < float(0))
            {
                BodyStanceNodes[I].GetCustomAnimNodeSeq().SetPosition(Duration - 0.010, false);
                Duration = -Duration;
            }
            // End:0x1E7
            if(!bKeepRBASettings)
            {
                BodyStanceNodes[I].SetRootBoneAxisOption(0, 0, 0);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x15;
    }
    return Duration;
    //return ReturnValue;    
}

// Export UFoxPawn_HardSuit::execPreProcessInput(FFrame&, void* const)
native simulated function PreProcessInput(FoxPlayerInput Input);

protected simulated function float PlayDeathAnimation(const class<DamageType> DamageType, const Vector HitLoc)
{
    local BodyStance TestBS;
    local float Length;

    TestBS.AnimName[0] = 'Death_A';
    Length = PlayFirstAndThirdPersonAnim(TestBS, 'None', 1.0, 0.250, -1.0, false, true);
    LeftEnginePSComp.SetHidden(true);
    RightEnginePSComp.SetHidden(true);
    Mesh.SetOwnerNoSee(false);
    SetVisorHidden(true);
    ToggleSprintEffects(false);
    return Length;
    //return ReturnValue;    
}

protected simulated function PlayDeathAudio(const class<DamageType> DamageType, const Vector HitLoc, const float DeathEffectTime)
{
    super(FoxPawn).PlayDeathAudio(DamageType, HitLoc, DeathEffectTime);
    PostAkEvent(AmbientHumStop);
    //return;    
}

protected simulated function PlayDeathFX(const class<DamageType> DamageType, const Vector HitLoc, const float DeathEffectTime)
{
    super(FoxPawn).PlayDeathFX(DamageType, HitLoc, DeathEffectTime);
    DeathLightComp.SetEnabled(true);
    SetTimer(DeathLightRampUpTime, false, 'RampUpFinished');
    //return;    
}

private final simulated function RampUpFinished()
{
    SetTimer(DeathLightRampDownTime, false, 'RampDownFinished');
    Mesh.SetHidden(true);
    HurtRadius(200.0, 512.0, class'FoxDamageType_Explosion', 600.0, Location);
    //return;    
}

private final simulated function RampDownFinished()
{
    DeathLightComp.SetEnabled(false);
    SetTimer(3.0, false, 'Destroy');
    //return;    
}

simulated function AttachDriver(Pawn P)
{
    local Rotator CurrentRot;

    // End:0x11
    if(!bAttachDriver)
    {
        return;
    }
    // End:0x111
    if(VisorMeshComp != none)
    {
        SetVisorHidden(false);
        VisorMeshComp.SetLightEnvironment(LightEnvironment);
        VisorMeshCompInner.SetLightEnvironment(LightEnvironment);
        CurrentRot = VisorMeshComp.Rotation;
        CurrentRot.Pitch = 0;
        VisorMeshComp.SetRotation(CurrentRot);
        VisorMeshCompInner.SetRotation(CurrentRot);
    }
    // End:0x1A9
    if(FoxPawn(P) != none)
    {
        // End:0x180
        if(FoxPawn(P).IsFirstPerson())
        {
            FoxPawn(P).SetFirstWeaponHidden(true);
        }
        // End:0x1A9
        else
        {
            FoxPawn(P).SetThirdPersonWeaponHidden(true);
        }
    }
    super.AttachDriver(P);
    //return;    
}

simulated function DetachDriver(Pawn P)
{
    // End:0x1A
    if(VisorMeshComp != none)
    {
        SetVisorHidden(true);
    }
    PostAkEvent(WeakPointArmorStop);
    // End:0xC6
    if(FoxPawn(P) != none)
    {
        // End:0x9D
        if(FoxPawn(P).IsFirstPerson())
        {
            FoxPawn(P).SetFirstWeaponHidden(false);
        }
        // End:0xC6
        else
        {
            FoxPawn(P).SetThirdPersonWeaponHidden(false);
        }
    }
    super.DetachDriver(P);
    //return;    
}

simulated function DrivingStatusChanged()
{
    super.DrivingStatusChanged();
    // End:0x24
    if(!bDriving)
    {
        ToggleSprintEffects(false);
    }
    //return;    
}

simulated function ToggleSprintEffects(const bool bEnabled)
{
    local editinline ParticleSystemComponent TempPS;
    local LinearColor NewColor;

    // End:0x169
    if(bEnabled)
    {
        // End:0x166
        if(WorldInfo.NetMode != NM_DedicatedServer)
        {
            NewColor = GetFlameColorsFor(IsFriendlyToLocalPlayer());
            LeftFootPSComp.SetHidden(false);
            RightFootPSComp.SetHidden(false);
            BaseBoostPSComp.SetHidden(false);
            LeftEnginePSComp.SetTemplate(LeftEngineBoostSystem);
            RightEnginePSComp.SetTemplate(RightEngineBoostSystem);
            LeftEnginePSComp.SetLinearColorParameter('Color', NewColor);
            RightEnginePSComp.SetLinearColorParameter('Color', NewColor);
        }
    }
    // End:0x3D5
    else
    {
        // End:0x387
        if(WorldInfo.NetMode != NM_DedicatedServer)
        {
            NewColor = GetFlameColorsFor(IsFriendlyToLocalPlayer());
            LeftFootPSComp.SetHidden(true);
            RightFootPSComp.SetHidden(true);
            BaseBoostPSComp.SetHidden(true);
            LeftEnginePSComp.SetTemplate(LeftEngineNormalSystem);
            RightEnginePSComp.SetTemplate(RightEngineNormalSystem);
            // End:0x387
            if(IsAliveAndWell())
            {
                TempPS = WorldInfo.MyEmitterPool.SpawnEmitterMeshAttachment(LeftEngineBoostShutdownSystem, Mesh, LeftEnginePSSocketName, true);
                TempPS.SetLinearColorParameter('Color', NewColor);
                TempPS = WorldInfo.MyEmitterPool.SpawnEmitterMeshAttachment(RightEngineBoostShutdownSystem, Mesh, RightEnginePSSocketName, true);
                TempPS.SetLinearColorParameter('Color', NewColor);
            }
        }
        // End:0x3D5
        if((Role < ROLE_Authority) && SpecialMove == 12)
        {
            SpecialMoves[12].RequestEndSpecialMove(0);
        }
    }
    // End:0x3FE
    if(Role == ROLE_Authority)
    {
        bBoostEnabled = bEnabled;
    }
    //return;    
}

simulated event LocalSetSprint(bool bTurnOn)
{
    // End:0x9D
    if(FoxPC(Controller) != none)
    {
        // End:0x65
        if(bTurnOn)
        {
            // End:0x62
            if(!IsDoingSpecialMove(12))
            {
                FoxPC(Controller).DoSpecialMove(12, false, false);
            }
        }
        // End:0x9D
        else
        {
            // End:0x9D
            if(IsDoingSpecialMove(12))
            {
                FoxPC(Controller).StopCurrentSpecialMove();
            }
        }
    }
    //return;    
}

// Export UFoxPawn_HardSuit::execIsSprinting(FFrame&, void* const)
native simulated function bool IsSprinting();

function ShouldCrouch(bool bCrouch)
{
    local bool bInSprint;

    bInSprint = IsDoingSpecialMove(12);
    super(FoxPawn).ShouldCrouch(bCrouch);
    // End:0x56
    if(bInSprint && bCrouch)
    {
        Stamina = 0.0;
    }
    //return;    
}

// Export UFoxPawn_HardSuit::execGetLeftWeapon(FFrame&, void* const)
native simulated function FoxWeapon GetLeftWeapon();

// Export UFoxPawn_HardSuit::execGetRightWeapon(FFrame&, void* const)
native simulated function FoxWeapon GetRightWeapon();

simulated function SetEmissives()
{
    local int I, J, NumTiles;
    local Texture BaseTexture;
    local LinearColor EmissiveColor;
    local FoxWeaponAttachment ThisAttach;
    local LinearColor OverlayColor;
    local float MetallicScalar;
    local Texture MetallicTexture;

    super.SetEmissives();
    // End:0x157
    if(CamoIndex != 255)
    {
        OverlayColor = class'FoxUnlockInfo'.default.BodyCamoUnlocks[CamoIndex].OverlayColor;
        MetallicScalar = class'FoxUnlockInfo'.default.BodyCamoUnlocks[CamoIndex].MetallicInterp;
        // End:0x154
        if(class'FoxUnlockInfo'.default.BodyCamoUnlocks[CamoIndex].MetallicTextureSwapRef != "")
        {
            MetallicTexture = Texture(DynamicLoadObject(class'FoxUnlockInfo'.default.BodyCamoUnlocks[CamoIndex].MetallicTextureSwapRef, class'Texture'));
        }
    }
    // End:0x1D1
    else
    {
        OverlayColor = class'FoxUnlockInfo'.default.BodyCamoUnlocks[0].OverlayColor;
        MetallicScalar = class'FoxUnlockInfo'.default.BodyCamoUnlocks[0].MetallicInterp;
    }
    class'FoxUnlockInfo'.static.GetBodyCamoTextures(BaseTexture, NumTiles, CamoIndex);
    // End:0x27E
    if(bDriving && PlayerReplicationInfo != none)
    {
        EmissiveColor = FoxGRI(WorldInfo.GRI).GetEmissiveColorForTeam(PlayerReplicationInfo);
    }
    // End:0x2A6
    else
    {
        EmissiveColor = MakeLinearColor(0.0, 0.0, 0.0, 1.0);
    }
    I = 0;
    J0x2B1:
    // End:0x3E7 [Loop If]
    if(I < TPCamoSwapLowerBodyMeshMICs.Length)
    {
        TPCamoSwapLowerBodyMeshMICs[I].SetVectorParameterValue(EmissiveParamName, EmissiveColor);
        TPCamoSwapLowerBodyMeshMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
        TPCamoSwapLowerBodyMeshMICs[I].SetVectorParameterValue(CamoColorOverlayParmName, OverlayColor);
        // End:0x3D9
        if(MetallicTexture != none)
        {
            TPCamoSwapLowerBodyMeshMICs[I].SetTextureParameterValue(CamoMetallicTextureParmName, MetallicTexture);
        }
        ++ I;
        // [Loop Continue]
        goto J0x2B1;
    }
    LowerBodyBurnMIC.SetVectorParameterValue(EmissiveParamName, EmissiveColor);
    LowerBodyBurnMIC.SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
    LowerBodyBurnMIC.SetVectorParameterValue(CamoColorOverlayParmName, OverlayColor);
    UpperBodyBurnMIC.SetVectorParameterValue(EmissiveParamName, EmissiveColor);
    UpperBodyBurnMIC.SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
    UpperBodyBurnMIC.SetVectorParameterValue(CamoColorOverlayParmName, OverlayColor);
    // End:0x5A8
    if(MetallicTexture != none)
    {
        LowerBodyBurnMIC.SetTextureParameterValue(CamoMetallicTextureParmName, MetallicTexture);
        UpperBodyBurnMIC.SetTextureParameterValue(CamoMetallicTextureParmName, MetallicTexture);
    }
    I = 0;
    J0x5B3:
    // End:0x7AF [Loop If]
    if(I < ThirdPersonWeaponAttachments.Length)
    {
        ThisAttach = ThirdPersonWeaponAttachments[I];
        // End:0x7A1
        if(ThisAttach != none)
        {
            J = 0;
            J0x602:
            // End:0x7A1 [Loop If]
            if(J < ThisAttach.CamoMICs.Length)
            {
                ThisAttach.CamoMICs[J].SetVectorParameterValue(EmissiveParamName, EmissiveColor);
                ThisAttach.CamoMICs[J].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
                ThisAttach.CamoMICs[J].SetVectorParameterValue(CamoColorOverlayParmName, OverlayColor);
                // End:0x793
                if(MetallicTexture != none)
                {
                    ThisAttach.CamoMICs[J].SetTextureParameterValue(CamoMetallicTextureParmName, MetallicTexture);
                }
                ++ J;
                // [Loop Continue]
                goto J0x602;
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x5B3;
    }
    //return;    
}

simulated function PlaySpawnLandEffects()
{
    // End:0x58
    if(SpawnDropPSComp != none)
    {
        SpawnDropPSComp.DeactivateSystem();
        SpawnDropPSComp.DetachFromAny();
        SpawnDropPSComp = none;
    }
    bTriggerSpawnEffects = false;
    //return;    
}

// Export UFoxPawn_HardSuit::execGetCenterWindowLocation(FFrame&, void* const)
native function Vector GetCenterWindowLocation();

simulated event BecomeViewTarget(PlayerController PC)
{
    local FoxPC LocalPC;

    LocalPC = FoxPC(GetALocalPlayerController());
    // End:0x103
    if((PC == LocalPC) && PC.Pawn == none)
    {
        // End:0x103
        if(LocalPC.PawnSpectateView != 1)
        {
            VisorMeshComp.SetOnlyOwnerSee(false);
            VisorMeshComp.SetHidden(true);
            VulnerableMeshComp.SetOwnerNoSee(false);
            Mesh.SetOwnerNoSee(false);
        }
    }
    //return;    
}

simulated event EndViewTarget(PlayerController PC)
{
    // End:0xA2
    if(PC.IsLocalPlayerController())
    {
        VisorMeshComp.SetOnlyOwnerSee(true);
        VulnerableMeshComp.SetOwnerNoSee(true);
        VulnerableMeshComp.SetHidden(true);
        Mesh.SetOwnerNoSee(true);
    }
    //return;    
}

simulated function SetFPSpectateFor(FoxPC InPC)
{
    SetVisorHidden(false);
    VulnerableMeshComp.SetOwnerNoSee(true);
    VisorMeshComp.SetLightEnvironment(LightEnvironment);
    VisorMeshCompInner.SetLightEnvironment(LightEnvironment);
    Mesh.SetOwnerNoSee(true);
    //return;    
}

simulated function ClearFPSpectateFor(FoxPC InPC)
{
    SetVisorHidden(true);
    VulnerableMeshComp.SetOwnerNoSee(false);
    Mesh.SetOwnerNoSee(false);
    //return;    
}

function SetupSpectateViewFor(FoxPC SpectatingPC)
{
    // End:0xE2
    if(SpectatingPC.PawnSpectateView == 1)
    {
        // End:0x69
        if(FoxInventoryManager(InvManager) != none)
        {
            FoxInventoryManager(InvManager).SetNetDirty();
        }
        bNetDirty = true;
        SpectatingPC.ClientAttachSpectateHSWeapons(LeftWeapon, LeftWeapon.Class, RightWeapon, RightWeapon.Class);
    }
    //return;    
}

// Export UFoxPawn_HardSuit::execIsFirstPerson(FFrame&, void* const)
native simulated function bool IsFirstPerson();

function bool ShouldGoToInjured(class<FoxDamageType> DamageType)
{
    return false;
    //return ReturnValue;    
}

function FoxWeaponConfigInfo GetWeaponConfigInfoFromDamageType(class<FoxDamageType> DamageType)
{
    local FoxWeaponConfigInfo Result;

    // End:0x4F
    if((LeftWeapon != none) && LeftWeapon.GetConfigInfoForWeapon(DamageType, Result))
    {
        return Result;
    }
    // End:0x9E
    if((RightWeapon != none) && RightWeapon.GetConfigInfoForWeapon(DamageType, Result))
    {
        return Result;
    }
    return Result;
    //return ReturnValue;    
}

function bool Died(Controller Killer, class<DamageType> DamageType, Vector HitLocation)
{
    // End:0xE2
    if(super.Died(Killer, DamageType, HitLocation))
    {
        // End:0xE0
        if((Killer != none) && OwningPlayerId != Killer.PlayerReplicationInfo.PlayerID)
        {
            FoxGame(WorldInfo.Game).ScoreEvent(FoxPRI(Killer.PlayerReplicationInfo), 28);
        }
        return true;
    }
    return false;
    //return ReturnValue;    
}

function PlayHitMarkerSound(FoxPC PawnPC, FoxPC InstigatedBy, class<DamageType> DamageType)
{
    // End:0x63
    if(class<FoxDamageType>(DamageType) != none)
    {
        InstigatedBy.NotifyDidDamage(class<FoxDamageType>(DamageType).static.GetHardSuitHitType(false));
    }
    // End:0x84
    else
    {
        InstigatedBy.NotifyDidDamage(0);
    }
    //return;    
}

simulated function NotifyFlashBanged(const float Strength, const bool bFriendlyFire)
{
    // End:0x6D
    if(IsLocallyControlled())
    {
        // End:0x3D
        if(RightWeapon != none)
        {
            RightWeapon.StopFire(0);
        }
        // End:0x6D
        if(LeftWeapon != none)
        {
            LeftWeapon.StopFire(0);
        }
    }
    super(FoxPawn).NotifyFlashBanged(Strength, bFriendlyFire);
    //return;    
}

function PancakeOther(Pawn Other)
{
    local int Damage;
    local class<DamageType> DamageType;
    local FoxSpecialMove_SprintDash DashSpecialMove;
    local FoxPawn OtherPawn;

    OtherPawn = FoxPawn(Other);
    // End:0x1E7
    if(!WasPawnAlreadyCrushed(OtherPawn))
    {
        // End:0x92
        if(Driver == none)
        {
            DamageType = CrushedDamageType;
            // End:0x80
            if(FoxPawn_ScorpionTank(OtherPawn) != none)
            {
                Damage = 2000;
            }
            // End:0x8F
            else
            {
                Damage = 50000;
            }
        }
        // End:0x16B
        else
        {
            // End:0x16B
            if(SpecialMove == 12)
            {
                DamageType = RunOverDamageType;
                DashSpecialMove = FoxSpecialMove_SprintDash(SpecialMoves[12]);
                // End:0x16B
                if(DashSpecialMove != none)
                {
                    DashSpecialMove.RequestEndSpecialMove(0);
                    // End:0x132
                    if(FoxPawn_ScorpionTank(OtherPawn) != none)
                    {
                        Damage = 4000;
                    }
                    // End:0x16B
                    else
                    {
                        // End:0x15C
                        if(FoxVehicle(OtherPawn) != none)
                        {
                            Damage = 1000;
                        }
                        // End:0x16B
                        else
                        {
                            Damage = 2000;
                        }
                    }
                }
            }
        }
        // End:0x1E7
        if(Damage > 0)
        {
            AddCrushedPawn(OtherPawn);
            Other.TakeDamage(Damage, GetCollisionDamageInstigator(), Location, Mass * Velocity, DamageType);
        }
    }
    //return;    
}

simulated function AttachWeaponToInactiveSlot(FoxWeapon W)
{
    // End:0x6E
    if((W != none) && W != Weapon)
    {
        SetSlotAttachment(W.WeaponSlot, W.WeaponAttachmentClass);
    }
    //return;    
}

simulated function bool CanDamageTypeBurnDriver(class<DamageType> BurningDamageType)
{
    // End:0x8A
    if(((BurningDamageType.Name == 'FoxDamageType_FlameThrower') || BurningDamageType.Name == 'FoxDamageType_IncendiaryFlare') || BurningDamageType.Name == 'FoxDamageType_FlamingCiv')
    {
        return true;
    }
    return false;
    //return ReturnValue;    
}

function FoxOnlineStatsWriteWeaponUse GetStatsWriteWeaponUse(class<FoxWeapon> WeaponClass)
{
    local FoxWeaponConfigInfo WeaponConfigInfo;
    local FoxWeapon WeaponUsed;
    local Inventory CurrInv;

    // End:0x28D
    if(FoxPRI(PlayerReplicationInfo) != none)
    {
        // End:0x6B
        if((LeftWeapon != none) && LeftWeapon.Class == WeaponClass)
        {
            WeaponUsed = LeftWeapon;
        }
        // End:0x1E2
        else
        {
            // End:0xBE
            if((RightWeapon != none) && RightWeapon.Class == WeaponClass)
            {
                WeaponUsed = RightWeapon;
            }
            // End:0x1E2
            else
            {
                // End:0x126
                if((MyFoxWeapon != none) && MyFoxWeapon.Class == WeaponClass)
                {
                    return FoxPRI(PlayerReplicationInfo).WeaponUsageStats;
                }
                // End:0x1E2
                else
                {
                    // End:0x1E2
                    if(InvManager != none)
                    {
                        CurrInv = InvManager.InventoryChain;
                        J0x15D:
                        // End:0x1E2 [Loop If]
                        if(CurrInv != none)
                        {
                            // End:0x1B7
                            if(CurrInv.Class == WeaponClass)
                            {
                                WeaponUsed = FoxWeapon(CurrInv);
                                // [Explicit Break]
                                goto J0x1E2;
                            }
                            CurrInv = CurrInv.Inventory;
                            // [Loop Continue]
                            goto J0x15D;
                        }
                    }
                }
            }
        }
        // End:0x28D
        if(WeaponUsed != none)
        {
            WeaponUsed.BuildWeaponConfigInfo(WeaponConfigInfo);
            // End:0x28D
            if(FoxPRI(PlayerReplicationInfo).PlayerStatsManager != none)
            {
                return FoxPRI(PlayerReplicationInfo).PlayerStatsManager.SetActiveWeaponStatsGroup(WeaponConfigInfo);
            }
        }
    }
    return none;
    //return ReturnValue;    
}

simulated function SetVisorHidden(const bool bShouldHide)
{
    // End:0x38
    if(VisorMeshComp != none)
    {
        VisorMeshComp.SetHidden(bShouldHide);
    }
    // End:0x70
    if(VisorMeshCompInner != none)
    {
        VisorMeshCompInner.SetHidden(bShouldHide);
    }
    //return;    
}

defaultproperties
{
    begin object name=LEPSComp class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxPawn_HardSuit.LEPSComp'
    LeftEnginePSComp=LEPSComp
    begin object name=REPSComp class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxPawn_HardSuit.REPSComp'
    RightEnginePSComp=REPSComp
    begin object name=LFComp class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxPawn_HardSuit.LFComp'
    LeftFootPSComp=LFComp
    begin object name=RFComp class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxPawn_HardSuit.RFComp'
    RightFootPSComp=RFComp
    begin object name=BaseComp class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxPawn_HardSuit.BaseComp'
    BaseBoostPSComp=BaseComp
    FriendlyFlameColor=(R=0.0,G=0.0,B=0.0,A=1.0)
    EnemyFlameColor=(R=0.0,G=0.0,B=0.0,A=1.0)
    CurrentVulnerablePointIndex=255
    HeatInterpParamName=Heat_Interp
    HeatInterpTime=4.0
    HeatInterpEndVal=1.0
    FrictionCoefficient=0.30
    CurrentVulnerablePoint=(AttachBoneName=None,BoneNames=none,AttachmentMesh=none,DamageModifier=10.0)
    BattleModeDamageModifier=0.50
    begin object name=VMeshComp class=StaticMeshComponent
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        HiddenGame=true
        bOwnerNoSee=true
        CastShadow=false
        CollideActors=false
        BlockActors=false
        BlockZeroExtent=false
        BlockNonZeroExtent=false
        BlockRigidBody=false
    object end
    // Reference: StaticMeshComponent'Default__FoxPawn_HardSuit.VMeshComp'
    VulnerableMeshComp=VMeshComp
    TurnScale=0.40
    begin object name=VisorComp class=SkeletalMeshComponent
        LowUpdateFrameRate=0
        ReplacementPrimitive=none
        bOnlyOwnerSee=true
        bSelfShadowOnly=true
        bCastShadowAsTwoSided=true
        Scale=2.0
    object end
    // Reference: SkeletalMeshComponent'Default__FoxPawn_HardSuit.VisorComp'
    VisorMeshComp=VisorComp
    begin object name=VisorCompInner class=StaticMeshComponent
        ReplacementPrimitive=none
        bOnlyOwnerSee=true
        bCastShadowAsTwoSided=true
        CollideActors=false
        BlockActors=false
        BlockZeroExtent=false
        BlockNonZeroExtent=false
        BlockRigidBody=false
        AbsoluteRotation=true
        Scale=1.50
    object end
    // Reference: StaticMeshComponent'Default__FoxPawn_HardSuit.VisorCompInner'
    VisorMeshCompInner=VisorCompInner
    VisorMeshMaxPitch=8000
    VisorMeshMinPitch=-5500
    VisorPitchDeadZone=1800
    VisorPitchPerSecond=3500
    VisorYawDeltaDegMax=34.0
    VisorYawDeltaDegMin=1.0
    AmbientHumRTPCName=Hardsuit_Move
    MyHardSuitEnterTime=0.50
    OtherHardSuitEnterTime=5.0
    DeathLightRampUpTime=3.20
    DeathLightRampUpIntensity=7.10
    DeathLightRampDownStartIntensity=10.0
    DeathLightRampDownTime=0.80
    WeakPointDuration=10.0
    WeakPointCooldown=40.0
    TargetLocationAdjustment=(X=0.0,Y=0.0,Z=100.0)
    MinCrushSpeed=600.0
    ForceCrushPenetration=32.0
    bIsMachine=true
    bUseWeaponAnimOverrides=false
    bTPCameraLocIsSocket=true
    bCanBeLungeTarget=false
    bOverrideZoomKey=true
    bDeathEffectPSIsSocket=true
    EnemyHVTMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_HardSuit.EnemyHVTMaterialInstance0'
    JamEnemyHVTMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_HardSuit.JamEnemyHVTMaterialInstance0'
    FriendlyHVTMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_HardSuit.FriendlyHVTMaterialInstance0'
    NuetralHVTMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_HardSuit.NuetralHVTMaterialInstance0'
    EnemyIRMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_HardSuit.EnemyIRMaterialInstance0'
    FriendlyIRMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_HardSuit.FriendlyIRMaterialInstance0'
    NuetralIRMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_HardSuit.NuetralIRMaterialInstance0'
    LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxPawn_HardSuit.FPLightEnvironmentObj'
    TakeDamageCameraShake=CameraShake'Default__FoxPawn_HardSuit.Shake0'
    BlendedEyeHeight=128.0
    EyeHeightBlendAccel=64.0
    AimOffsetMaxPawnDot=0.930
    Stamina=850.0
    StaminaRegenRatePerSecond=100.0
    MinimumStaminaToJump=1250.0
    MinimumStaminaToSprint=500.0
    JumpStaminaUsage=1000.0
    MaxElectrifiedEffectLength=0.250
    ElectrifiedLookMultiplier=0.80
    StunnedMovementMultiplier=0.0
    StunnedLookMultiplier=0.0
    SpecialMoveClasses(0)=none
    SpecialMoveClasses(1)=class'FoxSpecialMove_Jump'
    SpecialMoveClasses(2)=class'FoxSpecialMove_Land'
    SpecialMoveClasses(3)=class'FoxSpecialMove_VehicleSpawnLand'
    SpecialMoveClasses(4)=class'FoxSpecialMove_EnterLadder'
    SpecialMoveClasses(5)=class'FoxSpecialMove_ExitLadder'
    SpecialMoveClasses(6)=class'FoxSpecialMove_Injured'
    SpecialMoveClasses(7)=class'FoxSpecialMove_Revive'
    SpecialMoveClasses(8)=class'FoxSpecialMove_TauntFullBody'
    SpecialMoveClasses(9)=class'FoxSpecialMove_TauntUpperBody'
    SpecialMoveClasses(10)=class'FoxSpecialMove_TauntUpperBodyWalk'
    SpecialMoveClasses(11)=class'FoxSpecialMove_Idle'
    SpecialMoveClasses(12)=class'FoxSpecialMove_SprintDash'
    SpecialMoveClasses(13)=class'FoxSpecialMove_DeathAnim'
    SpecialMoveClasses(14)=class'FoxSpecialMove_WeaponDeathAnim'
    SpecialMoveClasses(15)=class'FoxSpecialMove_ToggleVisorOn'
    SpecialMoveClasses(16)=class'FoxSpecialMove_ToggleVisorOff'
    SpecialMoveClasses(17)=class'FoxSpecialMove_MeleeLunge'
    SpecialMoveClasses(18)=class'FoxSpecialMove_CaptureControlPoint'
    SpecialMoveClasses(19)=class'FoxSpecialMove_HackFail'
    SpecialMoveClasses(20)=class'FoxSpecialMove_VehicleActivate'
    SpecialMoveClasses(21)=class'FoxSpecialMove_MeleeLungeBlind'
    SpecialMoveClasses(22)=class'FoxSpecialMove_GroundPound'
    SpecialMoveClasses(23)=class'FoxSpecialMove_HulkCharge'
    SpecialMoveClasses(24)=class'FoxSpecialMove_AIEntry'
    SpecialMoveClasses(25)=class'FoxSpecialMove_Dodge'
    SpecialMoveClasses(26)=class'FoxSpecialMove_Stagger'
    SpecialMoveClasses(27)=class'FoxSpecialMove_Trip'
    SpecialMoveClasses(28)=class'FoxSpecialMove_Trip'
    SpecialMoveClasses(29)=class'FoxSpecialMove_Trip'
    SpecialMoveClasses(30)=class'FoxSpecialMove_Trip'
    SpecialMoveClasses(31)=class'FoxSpecialMove_Trip'
    SpecialMoveClasses(32)=class'FoxSpecialMove_PlantBomb'
    SpecialMoveClasses(33)=class'FoxSpecialMove_RemoveBomb'
    TPCameraLocName=Camera
    FreeCamLivingBoneName=Base
    FreeCamLivingBoneTranslation=(X=0.0,Y=0.0,Z=80.0)
    HealthRechargeDelay=5000.0
    HealthRechargePercentPerSecond=0.010
    HealthRechargeMaxPercent=0.0
    ExtraMachineHealthPct=0.333340
    HRVRechargeRate=0.50
    DamageProfiles(0)=(TakeDamageCameraShake=CameraShake'Default__FoxPawn_HardSuit.Shake1',DamageAmount=50)
    DamageProfiles(1)=(TakeDamageCameraShake=CameraShake'Default__FoxPawn_HardSuit.Shake2',DamageAmount=200)
    bCanCrouch=false
    bJumpCapable=false
    bCanClimbLadders=false
    bCanPickupInventory=false
    Mass=2000.0
    GroundSpeed=1100.0
    AirControl=0.0
    WalkingPct=0.250
    AccelRate=1000.0
    BaseEyeHeight=128.0
    EyeHeight=128.0
    Health=15000
    HealthMax=15000
    LandMovementState=PlayerWalking
    begin object name=PawnSkeletalMeshComponent class=SkeletalMeshComponent
        LowUpdateFrameRate=0
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxPawn_HardSuit.TPLightEnvironment'
        bOwnerNoSee=true
        bCastHiddenShadow=true
    object end
    // Reference: SkeletalMeshComponent'Default__FoxPawn_HardSuit.PawnSkeletalMeshComponent'
    Mesh=PawnSkeletalMeshComponent
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=128.0
        CollisionRadius=96.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPawn_HardSuit.CollisionCylinder'
    CylinderComponent=CollisionCylinder
    InventoryManagerClass=class'FoxInventorymanagerHardSuit'
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=128.0
        CollisionRadius=96.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPawn_HardSuit.CollisionCylinder'
    Components(0)=CollisionCylinder
    Components(1)=DynamicLightEnvironmentComponent'Default__FoxPawn_HardSuit.TPLightEnvironment'
    begin object name=PawnSkeletalMeshComponent class=SkeletalMeshComponent
        LowUpdateFrameRate=0
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxPawn_HardSuit.TPLightEnvironment'
        bOwnerNoSee=true
        bCastHiddenShadow=true
    object end
    // Reference: SkeletalMeshComponent'Default__FoxPawn_HardSuit.PawnSkeletalMeshComponent'
    Components(2)=PawnSkeletalMeshComponent
    Components(3)=DynamicLightEnvironmentComponent'Default__FoxPawn_HardSuit.FPLightEnvironmentObj'
    bCanStepUpOn=false
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=128.0
        CollisionRadius=96.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPawn_HardSuit.CollisionCylinder'
    CollisionComponent=CollisionCylinder
    RotationRate=(Pitch=20000,Yaw=16500,Roll=20000)
}